Index: branches/encoders/code/lib/include/libdragonfly/time.h
===================================================================
--- branches/encoders/code/lib/include/libdragonfly/time.h	(revision 1344)
+++ branches/encoders/code/lib/include/libdragonfly/time.h	(revision 1345)
@@ -1,4 +1,30 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
  * @file time.h
  * @brief Contains time-related functions and definitions
  *
@@ -11,10 +37,6 @@
 #ifndef _TIME_H_
 #define _TIME_H_
 
-/*Maximum # of functions*/
-#define MAX_FUNCTIONS 10
-
-
 /*	Predefined times for prescale_opt in time.c.
 	To make you own, know that a pulse is 1/16th of a second. You cannot get less than this. To get more, you need
 	to know how many 16ths of a second are in the time you want. (Time_desired * 16 = prescaler_opt)
@@ -41,19 +63,12 @@
 /** @brief Delay execution for the specified time **/
 void delay_ms(int ms) ;
 /** @brief Enable the realtime clock **/
-int rtc_multi_init(int* prescale_opt, void (*rtc_fun[])(void), int argc);
+void rtc_init(int prescale_opt, void (*rtc_func)(void));
 /** @brief Reset the counter of the realtime clock **/
 void rtc_reset(void);
 /** @brief Get the value of the realtime clock. **/
 int rtc_get(void);
 
-int rtc_add_function(void (*rtc_f) (void), int prescale_opt);
-
-int rtc_remove_function(void (*rtc_func)(void));
-int rtc_get_function_count(void);
-
-int rtc_init(int prescale_opt, void (*rtc_func)(void));
-
 /** @} **/
 
 #endif
Index: branches/encoders/code/lib/include/libdragonfly/motor.h
===================================================================
--- branches/encoders/code/lib/include/libdragonfly/motor.h	(revision 1344)
+++ branches/encoders/code/lib/include/libdragonfly/motor.h	(revision 1345)
@@ -1,4 +1,30 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
  * @file motor.h
  * @brief Contains definitions for controlling the motors
  *
Index: branches/encoders/code/lib/include/libdragonfly/analog.h
===================================================================
--- branches/encoders/code/lib/include/libdragonfly/analog.h	(revision 1344)
+++ branches/encoders/code/lib/include/libdragonfly/analog.h	(revision 1345)
@@ -1,5 +1,30 @@
 /**
+ * Copyright (c) 2007 Colony Project
  * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+/**
+ * 
  * @file analog.h
  * @brief Contains functions and definitions for using the ADC
  * 
@@ -12,11 +37,13 @@
 	
  * @author Colony Project, CMU Robotics Club, based on firefly
  * code by Tom Lauwers
-*/
+ */
 
 #ifndef _ANALOG_H
 #define _ANALOG_H
 
+#include <inttypes.h>
+
 /**
  * @addtogroup analog
  * @{
@@ -43,18 +70,20 @@
 /** @brief Analog port 9 **/
 #define AN9 0x09
 /** @brief Analog port 10 **/
-#define AN10 0x0a
+#define AN10 0x0A
 /** @brief Analog port 11 **/
-#define AN11 0x0b
+#define AN11 0x0B
 /** @brief Analog port 12 **/
-#define AN12 0x0c
+#define AN12 0x0C
 /** @brief Analog port 13 **/
-#define AN13 0x0d
+#define AN13 0x0D
 /** @brief Analog port 14 **/
-#define AN14 0x0e
+#define AN14 0x0E
 /** @brief Analog port 15 **/
-#define AN15 0x0f
+#define AN15 0x0F
 
+/** @brief BOM_PORT analog port for BOM **/
+#define BOM_PORT AN0
 /** @brief EXT_MUX analog port **/
 #define EXT_MUX AN7
 /** @brief Analog port for the wheel **/
@@ -62,15 +91,38 @@
 /** @brief Analog port for the battery voltage detector **/
 #define BATT_PORT  AN11
 
-/** @brief Initialize analog ports. **/
-void analog_init(void);
-/** @brief Read an 8-bit number from an analog port. **/
+#define ADC_START 1
+#define ADC_STOP 0
+
+#define ADMUX_OPT 0x60
+
+/** @brief Struct to hold the value of a particular analog port **/
+typedef struct {
+  uint8_t adc8;
+  uint16_t adc10;
+} adc_t;
+
+
+/** @brief Initialize analog ports. Will start running a loop
+    if start_conversion is ADC_START.**/
+void analog_init(int start_conversion);
+/** @brief starts the analog loop. Doesn't do anything if the loop is already running. **/
+void analog_start_loop(void);
+/** @brief Stops the analog loop. Doesn't do anything if the loop is already stopped. **/
+void analog_stop_loop(void);
+/** @brief Returns an 8-bit analog value from the look up table. Use this instead of analog_get8. **/
 unsigned int analog8(int which);
-/** @brief Read a 10-bit number from an analog port. **/
+/** @brief Returns an 10-bit analog value from the look up table. Use this instead of analog_get10. **/
 unsigned int analog10(int which);
 /** @brief Read the position of the wheel. **/
 int wheel(void);
+/** @brief Read an 8-bit number from an analog port. Loop must be stopped for this to work. **/
+unsigned int analog_get8(int which);
+/** @brief Read a 10-bit number from an analog port. Loop must be stopped for this to work. **/
+unsigned int analog_get10(int which);
 
+
 /**@}**/ //end group
 
 #endif
+
Index: branches/encoders/code/lib/include/libdragonfly/odometry.h
===================================================================
--- branches/encoders/code/lib/include/libdragonfly/odometry.h	(nonexistent)
+++ branches/encoders/code/lib/include/libdragonfly/odometry.h	(revision 1345)
@@ -0,0 +1,56 @@
+
+/**
+ * @file odometry.h
+ * @brief Code for estimating the robots pose.
+ * 
+ * Offers simple position and orientation information.
+ *
+ * @author Colony Project, CMU Robotics Club
+ **/
+
+#ifndef __ODOMETRY_C__
+#define __ODOMETRY_C__
+
+/**
+ * @addtogroup odometry 
+ * @{
+ **/
+
+//Odometry resolution, *64 microseconds.
+#define ODOMETRY_CLK 255u 
+#define TIME_SCALE 64
+
+//Wheel = 2.613 in.  
+//Circumference = 208.508133 mm
+//Distance per encoder click (circumference / 1024)  = 203.621224 um.
+//Robot width = 5.3745 in. = 136.5123 mm
+
+#define ROBOT_WIDTH_UM 137000  //um
+#define CLICK_DISTANCE_UM 204 //um
+
+#define DISTANCE_SCALE 2.10526316 //Magic constant.
+#define ANGLE_SCALE 1.12823207 //Magic constant.
+
+/** @brief Retrieve the robots estimated x position*/
+long odometry_dx(void);
+
+/** @brief Retrieve the robots estimated y position*/
+long odometry_dy(void);
+
+/** @brief Retrieve the robots estimated orientation*/
+double odometry_angle(void);
+
+/** @brief Initialize odometry. MUST be called before 
+ * the other functions work.**/
+void odometry_init(void);
+
+/** @brief Reset position and orientation to the origin facing
+ * the x axis.*/
+void odometry_reset(void);
+
+/** @brief Report estimated velocity [mm/s].*/
+long odometry_velocity(void);
+
+/**@}**/ //end group
+
+#endif
Index: branches/encoders/code/lib/include/libdragonfly/encoders.h
===================================================================
--- branches/encoders/code/lib/include/libdragonfly/encoders.h	(nonexistent)
+++ branches/encoders/code/lib/include/libdragonfly/encoders.h	(revision 1345)
@@ -0,0 +1,80 @@
+/**
+ * 
+ * @file encoders.h
+ * @brief Contains functions for reading encoder values.
+ *
+ * Contains high and low level functions for reading encoders
+ * including reading out total distance covered, and 
+ * eventually velocity.
+ *	
+ * @author Colony Project, CMU Robotics Club
+*/
+
+/**
+ * @addtogroup encoders
+ * @{
+ **/
+
+#ifndef __ENCODERS_H__
+#define __ENCODERS_H__
+
+
+#ifndef LEFT
+	#define LEFT 0
+#endif
+#ifndef RIGHT
+	#define RIGHT 1
+#endif
+
+/** @brief Magnet misaligned - likely distance from encoder problem. **/
+#define ENCODER_MAGNET_FAILURE 1025
+/** @brief Encoder misaligned - likely on XY plane. **/
+#define ENCODER_MISALIGNED 1027
+/** @brief Not enough time has passed - encoders not initialized in hardware. **/
+#define ENCODER_DATA_NOT_READY 1026
+
+//delay_ms argument after a full read is complete
+#define ENCODER_DELAY 20
+
+//Data invalid flags (hardware failure):
+#define OCF _BV(4)
+#define COF _BV(3)
+
+//Data invalid alarm (May be invalid):
+#define LIN _BV(2)
+
+#define MagINCn _BV(1)
+#define MagDECn _BV(0)
+
+//////////////////////////////
+//#define BUFFER_SIZE 23
+#define BUFFER_SIZE		46
+#define ERR_VEL			1024
+//////////////////////////////
+
+
+/** @brief Initialize encoders. **/
+void encoders_init(void);
+/** @brief Read instantaneous encoder value. **/
+int encoder_read(char encoder);
+/** @brief Currently a stub - DO NOT Use. **/
+char encoder_direction(char encoder);
+
+/** @brief Get total distance traveled. **/
+int encoder_get_dx(char encoder);
+/** @brief Reset distance counter. **/
+void encoder_rst_dx(char encoder);
+/** @brief Get time count: The number of encoder reads that have occurred. **/
+int encoder_get_tc(void);
+/** @brief Reset the time count. **/
+void encoder_rst_tc(void);
+
+/** @brief Still untested, so use at your own risk. **/
+int encoder_get_v(char encoder);
+
+/** @brief Waits for the next encoder reading, then returns. **/
+void encoder_wait( int nReadings );
+
+/**@}**/ //end group
+
+#endif
Index: branches/encoders/code/lib/include/libdragonfly/lcd.h
===================================================================
--- branches/encoders/code/lib/include/libdragonfly/lcd.h	(revision 1344)
+++ branches/encoders/code/lib/include/libdragonfly/lcd.h	(revision 1345)
@@ -1,4 +1,30 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
  * @file lcd.h
  * @brief Contains definitions for dealing with the LCD screen.
  * 
@@ -32,3 +58,4 @@
 /** @} **/
 
 #endif
+
Index: branches/encoders/code/lib/include/libdragonfly/move.h
===================================================================
--- branches/encoders/code/lib/include/libdragonfly/move.h	(revision 1344)
+++ branches/encoders/code/lib/include/libdragonfly/move.h	(revision 1345)
@@ -1,4 +1,30 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
  * @file move.h
  * @brief Contains definitions for controlling robot motion
  * 
Index: branches/encoders/code/lib/include/libdragonfly/battery.h
===================================================================
--- branches/encoders/code/lib/include/libdragonfly/battery.h	(revision 1344)
+++ branches/encoders/code/lib/include/libdragonfly/battery.h	(revision 1345)
@@ -1,4 +1,30 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
  * @file battery.h
  * @brief Definitions for checking battery voltage.
  * 
@@ -29,7 +55,7 @@
 int battery(void);
 /** @brief Check if the battery is low. **/
 char battery_low(void);
-/** @brief get an average battery voltage reading. **/
+/** @brief Get an average battery voltage reading. **/
 int battery8_avg(int n_samples);
 
 /** @} **/ //end addtogroup
Index: branches/encoders/code/lib/include/libdragonfly/dio.h
===================================================================
--- branches/encoders/code/lib/include/libdragonfly/dio.h	(revision 1344)
+++ branches/encoders/code/lib/include/libdragonfly/dio.h	(revision 1345)
@@ -1,4 +1,30 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
  * @file dio.h
  * @brief Definitions for digital input / output
  *
@@ -13,17 +39,17 @@
 #define _DIO_H
 
 /*
-these are ALL the pins
-don't use unless you know what you're doing
+  these are ALL the pins
+  don't use unless you know what you're doing
 */
 
 /*
-DIO pins on new dragonfly boards are shown below:
------------------------------------------------
-| _PIN_E6 | _PIN_E7 | _PIN_D2 | _PIN_D3 | VCC |
------------------------------------------------
-| _PIN_E2 | _PIN_E3 | _PIN_E4 | _PIN_E5 | GND |
------------------------------------------------
+  DIO pins on new dragonfly boards are shown below:
+  -----------------------------------------------
+  | _PIN_E6 | _PIN_E7 | _PIN_D2 | _PIN_D3 | VCC |
+  -----------------------------------------------
+  | _PIN_E2 | _PIN_E3 | _PIN_E4 | _PIN_E5 | GND |
+  -----------------------------------------------
 */
 
 /** @brief Port A **/
@@ -168,8 +194,8 @@
 //#define _PIN_G7 63
 
 /*
-These are the header pins (the ones you can connect things to)
-Feel free to use these
+  These are the header pins (the ones you can connect things to)
+  Feel free to use these
 */
 
 /**
Index: branches/encoders/code/lib/include/libdragonfly/dragonfly_lib.h
===================================================================
--- branches/encoders/code/lib/include/libdragonfly/dragonfly_lib.h	(revision 1344)
+++ branches/encoders/code/lib/include/libdragonfly/dragonfly_lib.h	(revision 1345)
@@ -1,74 +1,115 @@
-/**
- * @file dragonfly_lib.h
- * @brief Contains other include files
- * 
- * Include this file for all the functionality of libdragonfly.
- *
- * @author Colony Project, CMU Robotics Club
- **/
-
-#ifndef _DRAGONFLY_LIB_H_
-#define _DRAGONFLY_LIB_H_
-
-/**
- * @addtogroup dragonfly
- * @{
- **/
-
-// Configuration definitions
-/** @brief Initialize analog **/
-#define ANALOG 0x01
-/** @brief Initialize serial communications **/
-#define SERIAL 0x02
-/** @brief Initialize USB communications **/
-#define USB    0x02
-/** @brief Initialize communications **/
-#define COMM   0x02
-/** @brief Initialize the orb **/
-#define ORB    0x04
-/** @brief Initialize the motors **/
-#define MOTORS 0x08
-/** @brief Initialize the servos **/
-#define SERVOS 0x10
-/** @brief Initialize I2C **/
-#define I2C    0x20
-/** @brief Initialize the buzzer **/
-#define BUZZER 0x40
-/** @brief Initialize the LCD screen **/
-#define LCD    0x80
-/** @brief Initialize everything **/
-#define ALL_ON 0xFF
-
-
-/** @brief Initialize the board **/
-void dragonfly_init(int config);
-
-/** @} **/ //end addtogroup
-
-#include <inttypes.h>
-#include <stdio.h>
-#include <stdlib.h>
-#include <avr/io.h>
-#include <avr/interrupt.h>
-#include <util/delay.h>
-#include <util/twi.h>
-
-#include <analog.h>
-#include <dio.h>
-#include <time.h>
-#include <lcd.h>
-#include <lights.h>
-#include <motor.h>
-#include <serial.h>
-#include <buzzer.h>
-#include <rangefinder.h>
-#include <bom.h>
-#include <move.h>
-#include <reset.h>
-#include <math.h>
-
-#include <spi.h>
-#include <encoders.h>
-
-#endif
-
+/**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
+ * @file dragonfly_lib.h
+ * @brief Contains other include files
+ * 
+ * Include this file for all the functionality of libdragonfly.
+ *
+ * @author Colony Project, CMU Robotics Club
+ **/
+
+#ifndef _DRAGONFLY_LIB_H_
+#define _DRAGONFLY_LIB_H_
+
+/**
+ * @addtogroup dragonfly
+ * @{
+ **/
+
+// Configuration definitions
+/** @brief Initialize analog **/
+#define ANALOG 0x01
+/** @brief Initialize serial communications **/
+#define SERIAL 0x02
+/** @brief Initialize USB communications **/
+#define USB    0x02
+/** @brief Initialize communications **/
+#define COMM   0x02
+/** @brief Initialize the orb **/
+#define ORB    0x04
+/** @brief Initialize the motors **/
+#define MOTORS 0x08
+/** @brief Initialize I2C **/
+#define I2C    0x20
+/** @brief Initialize the buzzer **/
+#define BUZZER 0x40
+/** @brief Initialize the LCD screen **/
+#define LCD    0x80
+/** @brief Initialize the rangefinders **/
+#define RANGE  0x0100
+/** @brief Initialize the BOM **/
+#define BOM  0x0200
+/** @brief Initialize everything  **/
+#define ALL_ON 0x03FF
+
+/** @brief Initialize the board **/
+void dragonfly_init(int config);
+
+/** @} **/ //end addtogroup
+
+#include <inttypes.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <avr/io.h>
+#include <avr/interrupt.h>
+#include <util/delay.h>
+#include <util/twi.h>
+
+// This file is included from the libdragonfly directory because it seems to be
+// missing from the AVR libc distribution.
+#include "atomic.h"
+
+#include <analog.h>
+#include <dio.h>
+#include <time.h>
+#include <lcd.h>
+#include <lights.h>
+#include <motor.h>
+#include <serial.h>
+#include <buzzer.h>
+#include <rangefinder.h>
+#include <bom.h>
+#include <move.h>
+#include <reset.h>
+#include <math.h>
+#include <eeprom.h>
+#include <stdbool.h>
+
+/** @brief shortcut for ATOMIC_BLOCK(ATOMIC_RESTORESTATE) **/
+#define SYNC ATOMIC_BLOCK(ATOMIC_RESTORESTATE)
+
+/** @brief atomically grab a lock if it is free, return otherwise **/
+#define REQUIRE_LOCK_OR_RETURN(LOCK) do { SYNC { if (LOCK) return; LOCK=1; } } while (0)
+
+/** @brief atomically release a lock **/
+#define RELEASE_LOCK(LOCK) do { LOCK=0; } while (0)
+
+
+
+#endif
+
